﻿// Global vars
var currentStep = 1;
var sampleImage = false;
var displayAll = false;
var trigger = "";
var waitingForPS = false;
var loaded = false;

//
// Initialization
//

function TP_connectionOpened() {    
    // initTutorialState but save currentStep
    var savedCurrentStep = currentStep;
    initTutorialState();
    currentStep = savedCurrentStep;

    // logging
    logConnectedEvent();
}

function initTutorialState(){
    dismissDialogDiv();
    sampleImage = false;
    currentStep = 1;
    displayAll = false;
    trigger = "";
    waitingForPS = false;
}

function disableBackspaceNavigation() {
    $(document).unbind('keydown').bind('keydown', function (event) {
	var doPrevent = false;
	if (event.keyCode === 8) {
            var d = event.srcElement || event.target;
            if ((d.tagName.toUpperCase() === 'INPUT' && (d.type.toUpperCase() === 'TEXT' || d.type.toUpperCase() === 'PASSWORD')) 
		|| d.tagName.toUpperCase() === 'TEXTAREA') {
		doPrevent = d.readOnly || d.disabled;
            }
            else {
		doPrevent = true;
            }
	}

	if (doPrevent) {
            event.preventDefault();
	}
    });
}

//
// Utilities
//
function getTimeStamp(){
    var time = Math.round((new Date()).getTime() / 1000);
    var y = Math.round(time/(60*60*24*365))
    var yr = time%(60*60*24*365)
    var d = Math.round(yr/(60*60*24))
    var dr = yr%(60*60*24);
    var h = Math.round(dr/(60*60))
    var hr = dr%(60*60)
    var m = Math.round(hr/60)
    var s = hr%60

   return h+":"+m+":"+s
}

function regExpMatches(regExpString, testString){
    var pattern = new RegExp(regExpString);
    return pattern.test(testString);
}

function setPSHistory(str){

    var args = str.split(',')
    var numDocs = args[0];
    var currDoc = args[1];
    var historyLength = args[2];
    var lastHistoryAction = args[args.length-1];

    var debug = document.getElementById("debug");
    debug.innerHTML += getTimeStamp()+"<br>"
    debug.innerHTML += "<p><b>start of setPSHistory:</b>"+str+" <br/><b>currStep:</b> "+currentStep+" <br/><b>trigger:</b> "+trigger+" <br/><b>lastAction:</b>"+lastHistoryAction+"</p>";
    if (regExpMatches(trigger, lastHistoryAction)) {
	setCurrentStep(currentStep+1);
    }

    debug.innerHTML += "<p> <b>end of setPSHistory:</b>"+str+" <br><b>currStep:</b> "+currentStep+" <br><b>trigger: </b>"+trigger+" <br><b>lastAction:</b>"+lastHistoryAction+"</p>";
}

function refreshLayout() {
    setTimeout("document.body.scrollTop = document.body.scrollTop + 1", 10);
    setTimeout("document.body.scrollTop = document.body.scrollTop - 1", 20);
}

//
// Callbacks for specific types of events
//
function sendToolChange(str){
    var debug = document.getElementById("debug");
    debug.innerHTML += getTimeStamp()+"<br>"
    debug.innerHTML += "<p><b>start of sendToolChange:</b> "+str+" <br/><b>currStep:</b> "+currentStep+" <br/><b>trigger:</b> "+trigger+" </p>";

    if (regExpMatches(trigger, str)) {
	setCurrentStep(currentStep+1);
    }
    debug.innerHTML += "<p><b>end of sendToolChange:</b> "+str+" <br/><b>currStep:</b> "+currentStep+" <br/><b>trigger:</b> "+trigger+" </p>";
}


function hideLayer(){
    var debug = document.getElementById("debug");
    debug.innerHTML += getTimeStamp()+"<br>"
    debug.innerHTML += "<p><b>start of hideLayer:</b>  <br/><b>currStep:</b> "+currentStep+" <br/><b>trigger:</b> "+trigger+" </p>";

    if (regExpMatches(trigger, "HideLayer")) {
	setCurrentStep(currentStep+1);
    }
    debug.innerHTML += "<p><b>end of hideLayer:</b> <br/><b>currStep:</b> "+currentStep+" <br/><b>trigger:</b> "+trigger+" </p>";
}

function showLayer(){

    var debug = document.getElementById("debug");
    debug.innerHTML += getTimeStamp()+"<br>"
    debug.innerHTML += "<p><b>start of showLayer:</b>  <br/><b>currStep:</b> "+currentStep+" <br/><b>trigger:</b> "+trigger+" </p>";

    //if("ShowLayer" == trigger){
    if (regExpMatches(trigger, "ShowLayer")) {
	setCurrentStep(currentStep+1);
    }
    debug.innerHTML += "<p><b>end of showLayer:</b> <br/><b>currStep:</b> "+currentStep+" <br/><b>trigger:</b> "+trigger+" </p>";
}

function selectLayer(){
    var debug = document.getElementById("debug");
    debug.innerHTML += getTimeStamp()+"<br>"
    debug.innerHTML += "<p><b>start of selectLayer:</b>  <br/><b>currStep:</b> "+currentStep+" <br/><b>trigger:</b> "+trigger+" </p>";

    //if("SelectLayer" == trigger){
    if (regExpMatches(trigger, "SelectLayer")) {
	setCurrentStep(currentStep+1);
    }
    debug.innerHTML += "<p><b>end of selectLayer:</b> <br/><b>currStep:</b> "+currentStep+" <br/><b>trigger:</b> "+trigger+" </p>";
}

function copyCommand(){
    var debug = document.getElementById("debug");
    debug.innerHTML += getTimeStamp()+"<br>"
    debug.innerHTML += "<p><b>start of copyCommand:</b>  <br/><b>currStep:</b> "+currentStep+" <br/><b>trigger:</b> "+trigger+" </p>";

    //if("copy" == trigger){
    if (regExpMatches(trigger, "copy")) {
	setCurrentStep(currentStep+1);

    }
    debug.innerHTML += "<p><b>end of selectLayer:</b> <br/><b>currStep:</b> "+currentStep+" <br/><b>trigger:</b> "+trigger+" </p>";
}

//
// Get step information
//

function getCurrentStep(){
    return getStep(currentStep);
}

function getStep(stepNum) {
    var steps = document.getElementsByClassName("step-container");
    for (var j=0; j<steps.length; j++){ 
	if ((j+1)==stepNum) {
	    return steps[j];
	}
    }
    
    return null;
}

function getStepNum(stepDiv) {
    // find enclosing stepContainer
    var stepContainer = stepDiv;
    while (stepContainer && stepContainer.className != 'step-container') {
	stepContainer = stepContainer.parentElement;
    }

    if (stepContainer == null)
	return null;

    // extract stepNum from stepContainer
    var stepIdIndex = stepContainer.id.indexOf('step-');
    if (stepIdIndex > -1) {
	var stepString = stepContainer.id;
	var stepNumString = stepString.slice(stepIdIndex+5,stepString.length);
	return parseInt(stepNumString);
    }
}

function getScriptForStep(stepNum, showDialog){
    var script = document.getElementById("tbstep-" + stepNum);

    // strip <XML> tags from script string
    var scriptString = script.innerHTML;
    scriptString = scriptString.replace("<literal><![CDATA[","");
    scriptString = scriptString.replace("]]></literal>","");

    // update dialog mode if necessary
    if (showDialog)
	scriptString = scriptString.replace("DialogModes.NO", "DialogModes.ALL");

    return scriptString;
}

function getImageUrlForStep(stepNum) {
    var scriptDiv = document.getElementById("tbstep-" + stepNum);
    if (scriptDiv && scriptDiv.getAttribute("asset")) {
	var asset = scriptDiv.getAttribute("asset");
	if (asset.length > 0) {
	    var url = document.URL;
	    var urlParts = url.split('/');
	    var imageUrl = "";
	    for (var i=0; i<urlParts.length-1; i++)
		imageUrl += urlParts[i] + '/';
	    
	    imageUrl += asset;
	    return imageUrl;
	}
    }

    return null;
}

function getEventTriggerForStep(stepNum) {
    var stepDiv = getStep(stepNum);
    if (stepDiv && stepDiv.hasAttribute("eventtrigger"))
    {
	var eventtriggerObj = new Object;
	eventtriggerObj.eventtrigger = stepDiv.getAttribute("eventtrigger");
	eventtriggerObj.isCharEvent = (eventtriggerObj.eventtrigger.length <= 4);
	return JSON.stringify(eventtriggerObj);
    }
    
    return null;
}

function getHistoryTriggerForCurrentStep() {
    return getHistoryTriggerForStep(currentStep);
}

function getHistoryTriggerForStep(stepNum) {
    var stepDiv = getStep(stepNum);
    if (stepDiv && stepDiv.hasAttribute("historytrigger"))
	return stepDiv.getAttribute("historytrigger");
    
    return null;
}

function historyTriggerMatchesForCurrentStep(historyStr) {
    return historyTriggerMatchesForStep(currentStep, historyStr);
}

// TODO: eliminate duplication with setPSHistory
function historyTriggerMatchesForStep(stepNum, historyStr) {
    if (!historyStr)
	return false;

    var historyTrigger = getHistoryTriggerForStep(stepNum);

    var args = historyStr.split(',')
    var numDocs = args[0];
    var currDoc = args[1];
    var historyLength = args[2];
    var lastHistoryAction = args[args.length-1];

    //alert("Step " + stepNum + " historyTrigger = " + historyTrigger + " and lastHistoryAction = " + lastHistoryAction);

    return regExpMatches(historyTrigger, lastHistoryAction);
}

function getToolTriggerForCurrentStep() {
    return getToolTriggerForStep(currentStep);
}

function getToolTriggerForStep(stepNum) {
    var stepDiv = getStep(stepNum);
    if (stepDiv && stepDiv.hasAttribute("tooltrigger"))
	return stepDiv.getAttribute("tooltrigger");
    
    return null;
}

function toolTriggerMatchesForCurrentStep(toolStr) {
    return toolTriggerMatchesForStep(currentStep, toolStr);
}

function toolTriggerMatchesForStep(stepNum, toolStr) {
    var toolTrigger = getToolTriggerForStep(stepNum);
    return regExpMatches(toolTrigger, toolStr);
}

function isOpenImageStep(stepNum) {
    var stepDiv = getStep(stepNum);
    return (stepDiv && stepDiv.getAttribute("psid") == "File-Open");
}

function isCurrentDialogStep() {
    return isDialogStep(currentStep);
}

function isDialogStep(stepNum) {
    var stepDiv = getStep(stepNum);
    if (!stepDiv || !stepDiv.hasAttribute("hasdialog"))
	return false;
    
    return (stepDiv.getAttribute("hasdialog") == "true");
}

//
// Step update functions
//

function completedStep(stepId){

    var debug = document.getElementById("debug");
    debug.innerHTML += getTimeStamp()+"<br>"
    debug.innerHTML += "<p><b>start of function completed STEP:</b> "+stepId+" <br/><b>currStep:</b> "+currentStep+" <br/><b>trigger:</b> "+trigger+" </p>";

    //if (!isCurrentDialogStep()) {
    if (true) {
	var s = stepId.split('-');
	currentStep = parseInt(s[1]);
	setCurrentStep(currentStep+1);
	debug.innerHTML += "<p><b>end of function completed STEP:</b>"+stepId+" <br/><b>currStep:</b> "+currentStep+"<br/><b>trigger:</b> "+trigger+" </p>"
    };    
}

function setCurrentStepFromDiv(div) {
    if (!div)
	return;

    var stepNum = getStepNum(div);
    if (stepNum) {
	setCurrentStep(stepNum);
    }
}

function setCurrentStep(stepNum){
    dismissDialogDiv();
    currentStep = stepNum;
    updateCurrentStep();

    // logging
    logSetCurrentStep(stepNum);
}

function updateCurrentStep(){

    var currentStepDiv = getCurrentStep();
    if (!currentStepDiv)
	return;
    var currentStepDivHeight = currentStepDiv.clientHeight + currentStepDiv.style.paddingTop + currentStepDiv.style.paddingBottom;
    var currentStepDivTop = currentStepDiv.offsetTop;

    var showmes = document.getElementsByClassName("showme");

    if (currentStep > showmes.length) {
	var feedbackContainer = document.getElementById("totop");
	feedbackContainer.style.display = "block";

	var feedback = document.getElementById("feedback");

	if (sampleImage) {
	    feedback.innerHTML = "Good job! Now try this tutorial on your own image."
	}
	else {
	    feedback.innerHTML = "Nicely done!";
	}

	//initTutorialState();
    }
    else{
	var feedback = document.getElementById("feedback");
	feedback.innerHTML = "";	
	
	var feedbackContainer = document.getElementById("totop");
	feedbackContainer.style.display = "none";
    }

    for (var i=0; i<showmes.length; i++){ 
	if (((i+1) == currentStep) || displayAll) {
	    showmes[i].style.top = currentStepDivTop + (0.5*currentStepDivHeight) - 10 + 'px';
	    showmes[i].style.display = "block"; 
	}
	else
	    showmes[i].style.display = "none"; 
    }

    var steps = document.getElementsByClassName("step-container");
    for (var j=0; j<steps.length; j++){ 
	if ((j+1)==currentStep){
	    steps[j].style["background-color"] = "#DEDEDE";
	    trigger = steps[j].getAttribute("trigger");

	    if (currentStep == 1)
		makeElementVisible(document.getElementById("header"));
	    else
		makeElementVisible(steps[j]);
	}
	else
	    steps[j].style["background-color"] = "#EFEFEF"; 
    }
    
    // if editable, enable dblclick handler
    if ($("html").attr("editable") === "true") {
	$(currentStepDiv).dblclick(enableTextEditingForCurrentStep);
    }
}

//
// Functions for testing and animating element visibility
//

function getElementDistToVisible(elem)
{
    if (!elem)
	return 0;

    var buffer = 100;

    var distToVisible = 0;
    var elemTop = getElementTopPosition(elem);
    var elemBottom = elemTop + elem.clientHeight;

    var maxVisible = window.innerHeight;    
    var minVisible = 0;

    minVisible = document.getElementById("header").offsetTop;

    if (elemBottom + buffer > maxVisible)
	distToVisible = elemBottom + buffer - maxVisible;
    else if (elemTop - buffer < minVisible)
	distToVisible = elemTop - buffer - minVisible;

    return distToVisible;
}

function getElementTopPosition(elem){
    if (!elem)
	return 0;

    var top = 0;
    while (elem) {
	top += elem.offsetTop;
	elem = elem.offsetParent;
    }

    top = top - document.body.scrollTop;

    return top;
}

function makeElementVisible(elem) {

    if (!elem)
	return;

    // don't animate if we are currently editing
    if (isStepEditingEnabled() || isTextOnlyEditingEnabled())
	return;

    // clear any existing scrolling animation
    if (document.body.scrollAnimID)
	window.clearInterval(document.body.scrollAnimID);

    // get necessary dist to make element visible
    var elemDistToVisible = getElementDistToVisible(elem);

    if (Math.abs(elemDistToVisible) > 0)
    {
	var startScroll = document.body.scrollTop;
	var endScroll = startScroll + elemDistToVisible;
	if (endScroll < 0)
	    endScroll = 0

	// animate body scroll position
	var maxDuration = 1800;
	var animStep = 0;
	var totalSteps = Math.max(Math.abs(endScroll - startScroll)/8, 10);
	var stepDuration = 30;
	if (totalSteps * stepDuration > maxDuration)
	    stepDuration = maxDuration / totalSteps;

	document.body.scrollAnimID = window.setInterval(
	    function() {
		document.body.scrollTop = easeInOut(startScroll, endScroll, totalSteps, animStep, 3);
		animStep++;
		if (animStep > totalSteps) window.clearInterval(document.body.scrollAnimID);
	    }
	    , stepDuration);
    }
}

function easeInOut(minValue, maxValue, totalSteps, actualStep, powr) { 
    totalSteps = Math.max(totalSteps,1)
    var delta = maxValue - minValue; 
    var x = actualStep / totalSteps;
    x = (3*x*x) - (2*x*x*x);
    var step = minValue + x * delta;
    return Math.ceil(step);
} 

//
// Functions for resizing layout
//
function updateBeforeAfterImgSizes() {
    var beforeImg = document.getElementById("beforeImg");
    var beforeImgAspectRatio = beforeImg.clientWidth / beforeImg.clientHeight;
    var afterImg = document.getElementById("afterImg");
    var afterImgAspectRatio = afterImg.clientWidth / afterImg.clientHeight;
    var beforeAfterDiv = document.getElementById("beforeAfter");
    var beforeDiv = document.getElementById("before");
    var afterDiv = document.getElementById("after");
    var headerDiv = document.getElementById("header");
    var headerDescTextDiv = document.getElementById("text");
    var stepsDiv = document.getElementById("steps");

    // PORTRAIT
    if (window.innerWidth <= 768)
    {
	// reset divs
	beforeAfterDiv.style.width = '768px';
	beforeAfterDiv.style.height = '325px';
	beforeDiv.style.height = 'auto';
	beforeDiv.style.paddingTop = '0px';
	afterDiv.style.height = 'auto';
	afterDiv.style.paddingTop = '0px';
	headerDiv.style.width = '708px';
	headerDiv.style.marginTop = '325px';
	headerDiv.style.marginLeft = '0px';
	headerDescTextDiv.style.width = '618px';
	stepsDiv.style.width = '728px';
	stepsDiv.style.marginLeft = '0';

	// reset imgs to original dimensions
	beforeImg.style.height = (0.75*325) + 'px';
	beforeImg.style.width = (beforeImg.clientHeight*beforeImgAspectRatio) + 'px';
	afterImg.style.height = (0.75*325) + 'px';
	afterImg.style.width = (afterImg.clientHeight*afterImgAspectRatio) + 'px';

	var arr = document.getElementsByTagName("div");
	for (i = 0; i < arr.length; i++) {
	    if (arr[i].hasAttribute("class") && arr[i].getAttribute("class") == "step")
		arr[i].style.width = '638px';

	    else if (arr[i].hasAttribute("class") && arr[i].getAttribute("class") == "stepText")
		arr[i].style.width = '465px';

	    else if (arr[i].hasAttribute("id") && arr[i].getAttribute("id") == "feedback")
		arr[i].style.width = '606px';
	}	

	var maxWidth = beforeImg.clientWidth;
	if (afterImg.clientWidth > maxWidth)
	    maxWidth = afterImg.clientWidth;

	// update img dimensions if necessary
	if (maxWidth > 340)
	{
	    beforeImg.style.width = 340 + 'px';
	    beforeImg.style.height = (340/beforeImgAspectRatio) + 'px';

	    afterImg.style.width = 340 + 'px';
	    afterImg.style.height = (340/afterImgAspectRatio) + 'px';
	}

	var maxHeight = beforeImg.clientHeight;
	if (afterImg.clientHeight > maxHeight)
	    maxHeight = afterImg.clientHeight;

	var totalImgWidth = beforeImg.clientWidth + afterImg.clientWidth;
	var totalFreeWidth = 768 - totalImgWidth;
	beforeDiv.style.width = beforeImg.clientWidth + 'px';
	beforeDiv.style.paddingLeft = (totalFreeWidth/3) + 'px';
	afterDiv.style.width = afterImg.clientWidth + 'px';
	afterDiv.style.paddingRight = (totalFreeWidth/3) + 'px';

	if (beforeImg.clientHeight > afterImg.clientHeight)
	    afterImg.style.marginTop = (beforeImg.clientHeight-afterImg.clientHeight) + 'px';
	else if (afterImg.clientHeight > beforeImg.clientHeight)
	    beforeImg.style.marginTop = (afterImg.clientHeight-beforeImg.clientHeight) + 'px';

	beforeAfterDiv.style.height = (maxHeight + 75) + 'px';
	headerDiv.style.marginTop = (maxHeight + 75) + 'px';
    }
    // LANDSCAPE
    else
    {
	// reset divs
	beforeAfterDiv.style.height = '100%';
	beforeDiv.style.width = '100%';
	beforeDiv.style.paddingLeft = '0px';
	beforeImg.style.marginTop = '0px';
	afterDiv.style.width = '100%';
	afterDiv.style.paddingRight = '0px';
	afterImg.style.marginTop = '0px';
	headerDiv.style.marginTop = '0px';

	// reset imgs to original dimensions
	beforeImg.style.height = (0.4*beforeAfterDiv.clientHeight) + 'px';
	beforeImg.style.width = (beforeImg.clientHeight*beforeImgAspectRatio) + 'px';
	afterImg.style.height = (0.4*beforeAfterDiv.clientHeight) + 'px';
	afterImg.style.width = (afterImg.clientHeight*afterImgAspectRatio) + 'px';

	var maxWidth = beforeImg.clientWidth;
	if (afterImg.clientWidth > maxWidth)
	    maxWidth = afterImg.clientWidth;

	// update img dimensions if necessary
	var maxAllowedWidth = 310;
	if (maxWidth > maxAllowedWidth)
	{
	    beforeImg.style.width = maxAllowedWidth + 'px';
	    beforeImg.style.height = (maxAllowedWidth/beforeImgAspectRatio) + 'px';

	    afterImg.style.width = maxAllowedWidth + 'px';
	    afterImg.style.height = (maxAllowedWidth/afterImgAspectRatio) + 'px';
	}

	// center images vertically
	var maxHeight = beforeImg.clientHeight;
	if (afterImg.clientHeight > maxHeight)
	    maxHeight = afterImg.clientHeight;

	var totalImgHeight = beforeImg.clientHeight + afterImg.clientHeight + 65;
	var totalFreeHeight = window.innerHeight - totalImgHeight;
	beforeDiv.style.height = beforeImg.clientHeight + 40 + 'px';
	beforeDiv.style.paddingTop = (totalFreeHeight/3) + 'px';
	afterDiv.style.height = afterImg.clientHeight + 40 + 'px';
	afterDiv.style.paddingTop = (totalFreeHeight/3) + 'px';

	// adjust width of image region
	maxWidth = beforeImg.clientWidth;
	if (afterImg.clientWidth > maxWidth)
	    maxWidth = afterImg.clientWidth;

	var beforeAfterDivWidth = maxWidth + 60;
	beforeAfterDiv.style.width = beforeAfterDivWidth + 'px';
	var headerDivWidth = 1024 - 60/*padding-left|right*/ - beforeAfterDivWidth;
	headerDiv.style.width = headerDivWidth + 'px';
	headerDiv.style.marginLeft = beforeAfterDivWidth + 'px';
	var headerDescTextDivWidth = headerDivWidth - 72/*goal.width*/ - 10/*space*/;
	headerDescTextDiv.style.width = headerDescTextDivWidth + 'px';
	var stepsDivWidth = 1024 - 24/*padding-left|right*/ - beforeAfterDivWidth;
	stepsDiv.style.width = stepsDivWidth + 'px';
	stepsDiv.style.marginLeft = beforeAfterDivWidth + 'px';

	var arr = document.getElementsByTagName("div");
	for (i = 0; i < arr.length; i++) {
	    if (arr[i].hasAttribute("class") && arr[i].getAttribute("class") == "step")
		arr[i].style.width = stepsDivWidth - 80/*stepNum.width*/ - 10/*step.padding-left*/ + 'px';

	    else if (arr[i].hasAttribute("class") && arr[i].getAttribute("class") == "stepText")
		arr[i].style.width = stepsDivWidth - 80/*stepNum.width*/ - 10/*step.padding-left*/ - 100/*stepLink.width*/ - 50/*space*/ + 'px';

	    else if (arr[i].hasAttribute("id") && arr[i].getAttribute("id") == "feedback")
		arr[i].style.width = stepsDivWidth - 36/*padding-left/right*/ - 102/*a.totop.width*/ - 30/*stepLink.padding-right*/ - 30/*space*/ + 'px';
	}	
    }

    var stepsHeight = stepsDiv.offsetHeight;
    var headerHeight = headerDiv.offsetHeight;
    var tutorialTextHeight = stepsHeight + headerHeight;
    if (stepsHeight < (window.innerHeight-beforeAfterDiv.offsetHeight-headerDiv.offsetHeight))
	stepsDiv.style.height = (window.innerHeight-beforeAfterDiv.offsetHeight-headerDiv.offsetHeight);

    refreshLayout();
}

//
// Code for handling showme behavior
//

function showMeClicked() {
    if (isCurrentDialogStep())
	dialogStepClicked();
    else
	setWaitingForPS(true);

    // update sampleImage flag
    if (currentStep == 1)
	sampleImage = true;

    // logging
    logShowMeClicked(currentStep);
}

function photoshopError() {
    dismissDialogDiv();
}

function setWaitingForPS(value) {

    // get current step
    var currentStepDiv = getCurrentStep();
    if (!currentStepDiv)
	return;

    waitingForPS = value;
    
    // update show me button
    var children = currentStepDiv.getElementsByClassName("showme");
    if (children.length != 1)
	return;

    if (value == true)
	children[0].style.background = "url('images/showmeWaiting.gif') 0 0 no-repeat";
    else 
	children[0].style.background = "url('images/showme.png') 0 0 no-repeat";

}

//
// Code for handling dialog steps
//

function dialogStepClicked() {
    // set waitingForPS to true
    setWaitingForPS(true);
    
    // show dialog div
    updateDialogDiv();
}

function updateDialogDiv() {
    // if not waitingForPS, do nothing
    if (!waitingForPS)
	return;

    // get current step
    var currentStepDiv = getCurrentStep();
    if (!currentStepDiv)
	return;

    var dialogContainer = document.getElementById("dialog-container");
    var dialog = document.getElementById("dialog");
    var dialogTitle = document.getElementById("dialog-title");
    var dialogMsg = document.getElementById("dialog-message");
    var dialogStep = document.getElementById("dialog-step");
    var dialogStepNum = document.getElementById("dialog-stepNum");
    var dialogStepText = document.getElementById("dialog-stepText");
    var dialogReset = document.getElementById("dialog-reset");

    dialogContainer.style.display = 'block';    

    var currentStepMaxHeight = 0.9*window.innerHeight - dialogTitle.clientHeight - dialogMsg.clientHeight - dialogReset.clientHeight - dialog.style.paddingTop - dialog.style.paddingBottom;
    dialogStep.style.maxHeight = currentStepMaxHeight + 'px';
    dialogStepNum.innerHTML = 'Step ' + currentStep + ':';
    dialogStepText.innerHTML = '';

    // update dialog size to match step and fill innerHTML with step
    var children = currentStepDiv.getElementsByClassName("stepText");
    if (children.length == 1) {    
	var dialogWidth = children[0].clientWidth +
    20/*stepText.padding-left/right*/ + 80/*stepNum.width*/ + 15;
	dialog.style.width = dialogWidth + 'px';
	dialogStep.style.width = dialogWidth + 'px';
	dialogStepText.style.width = children[0].clientWidth + 'px';
	dialogStepText.innerHTML = children[0].innerHTML;
    }

    // center dialog vertically
    dialog.style.top = 0.5 * (window.innerHeight - dialog.clientHeight);

    refreshLayout();
}

function dismissDialogDiv() {
    // set waitingForPS to false
    setWaitingForPS(false);

    // hide dialog div
    var dialogContainer = document.getElementById("dialog-container");
    dialogContainer.style.display = 'none';
}

//
// Standard JS callbacks
//

function load() {

    var beforeImg = document.getElementById("beforeImg");
    var afterImg = document.getElementById("afterImg");

    updateBeforeAfterImgSizes();
    updateCurrentStep();

    // disable backspace/delete button from navigating
    disableBackspaceNavigation();

    // if editable, enable editing features
    if ($("html").attr("editable") === "true") {
	// bind dblclick handlers to enable editing
	$(".title").bind('dblclick', enableTextEditingForDiv);
	$(".author").bind('dblclick', enableTextEditingForDiv);
	$(".description-text").bind('dblclick', enableTextEditingForDiv);

	// add keyup behavior
	$("body").keyup(keyUp);

	// create save/export buttons if necessary
	if ($("#save").length == 0)
	    $("#tutorial-text").append($('<a id="save"><span/></a>'));	    
	if ($("#export").length == 0)
	    $("#tutorial-text").append($('<a id="export"><span/></a>'));	    

	// show save/export buttons
	$("#save").css("display","block");
	disableSaveButton();
	$("#export").css("display","block");

	// create invisible add-image button if necessary
	if ($("#add-image").length == 0)
	    $("#tutorial-text").append($('<input id="add-image" type="button" style="position:absolute; opacity:0.0;"/>'));
    }
    // if not editable, disable editing features
    else {
	// unbind dblclick handlers
	$(".title").unbind('dblclick');
	$(".author").unbind('dblclick');
	$(".description-text").unbind('dblclick');

	// remove keyup behavior
	$("body").unbind("keyup");

	// remove save/export buttons
	$("#save").remove();
	$("#export").remove();

	// remove invisible add-image button
	$("#add-image").remove();
    }

    // initialize logging
    initLogging();

    loaded = true;
}

function orientationChanged(e) {

    if (loaded) {
	updateBeforeAfterImgSizes();
	makeElementVisible(getCurrentStep());
	updateDialogDiv();
	updateCurrentStep();
    } 
    else {
	setTimeout(orientationChanged(e), 500);
    }

}

//
// Register callbacks
//
window.onload = load;
window.onorientationchange = orientationChanged;

(function($) {
	

var list;
var selectedIndex = -1;
var speed 		  = 100;//100;

$(document).keypress(function(e){
	 var code = e.keyCode;
	 if(e.keyCode==0)code=e.charCode;
	 switch( code ) {
	 	//down or J
	   case 40:
	   case 106:
	      node = list[++selectedIndex];
	      if (node) {
	        $.scrollTo( node, speed);
	      }
	      else {
	        selectedIndex = list.length-1;
	        node = list[selectedIndex];
	      }
	      break;
	    case 38:
	    case 107:
	    //up or K
	    node = list[--selectedIndex];
	    if (node) {
	       $.scrollTo( node, speed);
	    }
	     else {
	          selectedIndex = -1;
	          $.scrollTo('html');
	          node = null;
	        }
	       break;
	    /*
	    case 100:
	    	$(".description .body").toggle();
	    	if (node) {
	         	$.scrollTo( node, speed);
	       	}
	    	break;
	   	case 104:
	   		 selectedIndex = -1;
	    	 $.scrollTo('html');
	    	 node = null;
	    	break;
	   	case 118:
	    	if (node) {
	    	 	var url = $(node).children('a').attr('href');
	    	 	window.location = url;
	    	}
	    	break;
	   */
	}
});


$(window).scroll(function(){
	var scrolltop 	= $(window).scrollTop();
	var scrollright = $(window).scrollLeft();
	var winheight 	= $(window).height();
	var shouldLoad  = scrolltop == $(document).height() - winheight;
});

var init = function(){
	list = $('.step');
	$("a:has(img)").fancybox({overlayOpacity:0.5,overlayColor:'#000'});
}

$(init);

})(jQuery);


function moreDesc() {
	var content;
	var more=$('.moreButton').text();
	if(more=='MORE') {
	 content = $('#description-long').text();
	 $('.moreButton').text('LESS');
	} else {
	 content = $('#description-short').text();
	 $('.moreButton').text('MORE');
	}
	console.log(more + content);
	$('#description').text(content);
	
	return false;

}


