#target photoshop
//
// CaptureLogClean.jsx
//
// Copyright: (c)2010, xbytor
// License: http://www.opensource.org/licenses/bsd-license.php
// Contact: xbytor@gmail.com
//

function CaptureLog_capture(destFolder) {

    // Grab source Script Listener Log file
    var sourceLogFilename = destFolder + '/ScriptingListenerJS.log';
    var sourceLogFile = new File(sourceLogFilename);
    if (!sourceLogFile.exists) {
      Error.runtimeError(9002, "Script Listener Log file not found: " +
                         sourceLogFile.toUIString());
    }
    sourceLogFile.encoding = (isWindows() ? 'CP1252' : 'MACINTOSH');    

    // Check that destination XML file location is valid
    var destXMLFilename = destFolder + '/Capture.xml';
    var destXMLFile = new File(destXMLFilename);
    if (!destXMLFile.open("w")) {
	return self.errorPrompt("Unable to open capture XML file for writing: " + destXMLFile.error);
    }
    destXMLFile.close();
    destXMLFilename = decodeURI(destXMLFilename);

    // Set up parser
    SLCParser.usePSConstants = false;
    var parser = new SLCParser();

    parser.exec(sourceLogFile, undefined);

    if (parser.errorCnt > 0) {
      var msg = ("There were %d errors encountered while parsing the file.\n" +
                 "Details can be found in " + CaptureLogOptions.LOG_FILE);
      msg = msg.sprintf(parser.errorCnt);
      alert(msg);
      if (!confirm("Continue Processing?")) {
        return;
      }
    }

    // Create XML version of parsed items

    var items = parser.items;
    var action = new Action();
    var itemList = new XML('<ActionItemList/>');

    for (var i = 0; i < items.length; i++) {
      var item = items[i];
      var aitem = new ActionItem();
      aitem.withDialog = (item.mode != DialogModes.NO);
      if (item.event) {
        aitem.setEvent(item.event);
      } else {
        aitem.setItemID(item.eid);
      }
      aitem.setDescriptor(item.desc);
      aitem.name = item.name;

      Stdlib.log(aitem.name);

      var axml = aitem.toXML('ActionItem');
      if (axml.constructor == String) {
        axml = new XML(axml);
      }

      // do a little cleanup on the ActionItem
      delete axml.@expanded;
      delete axml.@dialogOptions;
      delete axml.@identifier;

      // insert source code
      if (item.literal) {

          var s = '<literal><![CDATA[';
          s += item.literal;
          s += ']' + ']></literal>';
          axml.literal = new XML(s);
      }
      // if (item.src) {
      //   axml.src = new XML('<src><![CDATA' + '[' + item.src + ']' + ']></src>');
      // }
      itemList.appendChild(axml);
    }

    var xml = new XML('<DemoCapture/>');

    xml.Source = sourceLogFilename;
    xml.Date = new Date().toString();

    xml.appendChild(itemList);

    // Write out Capture XML file 
    Stdlib.writeXMLFile(destXMLFilename, xml);
};

