
//
// Global variables
//
var slFile = new File("~/desktop/scriptinglistenerjs.log");
slFile.open('r');
var outFile = null;

/**
 * Accumulate next operation from ScriptListener file.
 **/
function getNextOperation(slFile) {
    var operationString = new String();
    var endOperation = new RegExp ("executeAction*", "i");
    while (!slFile.eof) {
		var nextLine = slFile.readln();
		operationString = operationString.concat(nextLine);
		operationString = operationString.concat("\n");
		if (endOperation.test(nextLine)) {
			break;
		} 
    }
    return operationString;
}

/**
 * Write out operation to file
 **/
function writeOperation(operationString, outFile) {
	if (outFile) {
		outFile.writeln(operationString);
	}
}

/**
 * Parse operation; write if necessary
 **/
function parseOperation(operationString) {

	// skip automation script calls
	if (operationString.search("AdobeScriptAutomation") >= 0) {
		return;
	}
	
	// write to outFile
	if (!outFile) {
		// ask user to specify output log file
		outFile = File.saveDialog("Save output log file as", "*.log");
		if (outFile) {
			outFile.open('w');
		}
	}

	if (outFile) {
		outFile.writeln(operationString);
	}
}

/**
 * Main
 **/
while (!slFile.eof) {
	// get next operation from ScriptListener file
	var nextOperation = getNextOperation(slFile);

	// parse next operation; write if necessary
	parseOperation(nextOperation);
}

if (outFile) {
	// display alert
	alert("Stopped tutorial recording.  Output log saved to " + outFile.fsName, "Tutorial Builder");
	outFile.close();
} else {
	alert("Error: invalid output log file", "Tutorial Builder", true);
}


